/* This software comprises contributed code made by Motorola, as a
 * Contributor, to Network Simulator NS-2 software provided by the
 * Regents of the University of California.
 * (Copyright; Regents of the University of California, 1994)
 * The contributed code was made as a result of a partnership between
 * Motorola and INRIA Rhone-Alpes.
 *
 * Copyright in the contributed code belongs to Motorola Inc. 2001
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ALL ADVERTISING MATERIALS MENTIONING FEATURES OR USE OF THIS SOFTWARE MUST
 * DISPLAY AN ACKNOWLEDGEMENT TO THE COPYRIGHT OWNERS.
 * ANY REDISTRIBUTION OF THIS SOFTWARE MUST CONTAIN THE ABOVE COPYRIGHT NOTICES,
 * CONDITIONS AND DISCLAIMER.
 */

/* ############################################################################
 * This code was developed by Mickael Vera (1999)
 * MOTOROLA Labs Paris FRANCE
 * NS-2.1b6 enhancements for Wide-Area mobility simulations
 * ############################################################################
 */



#ifndef ADDRESSES_H
#define ADDRESSES_H

#define MAX_DOMAINS 120 
#define MAX_CLUSTER_PER_DOMAIN 250 
#define MAX_NODE_PER_CLUSTER 250 

#define MAX_ADDRESS_STRING_SIZE 25
#define MAX_ADDR_DOMAIN_STRING_SIZE 10000

/* struct address */
struct address ;
typedef struct address * address ;

address
new_address (int domain, int cluster, int node) ;

void 
delete_address (address A) ;

char *
address2string (address Add) ;

/* struct addr_domain */
struct addr_domain ;
typedef struct addr_domain * addr_domain ;

addr_domain
new_addr_domain () ;

void
delete_addr_domain (addr_domain A) ;

int
new_domain (addr_domain Addr_domain) ;

int
new_cluster (addr_domain Addr_domain, int Domain) ;

int
new_node (addr_domain Addr_domain, int Domain, int Cluster) ;

int
nb_clusters(addr_domain A, int Domain) ;

int
nb_domains(addr_domain A) ;

int
nb_nodes (addr_domain A, int Domain, int Cluster) ;

char *
get_addr_domain (addr_domain A) ;

#endif /* ADDRESSES_H */
