/* This software comprises contributed code made by Motorola, as a
 * Contributor, to Network Simulator NS-2 software provided by the
 * Regents of the University of California.
 * (Copyright; Regents of the University of California, 1994)
 * The contributed code was made as a result of a partnership between
 * Motorola and INRIA Rhone-Alpes.
 *
 * Copyright in the contributed code belongs to Motorola Inc. 2001
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ALL ADVERTISING MATERIALS MENTIONING FEATURES OR USE OF THIS SOFTWARE MUST
 * DISPLAY AN ACKNOWLEDGEMENT TO THE COPYRIGHT OWNERS.
 * ANY REDISTRIBUTION OF THIS SOFTWARE MUST CONTAIN THE ABOVE COPYRIGHT NOTICES,
 * CONDITIONS AND DISCLAIMER.
 */

/* ############################################################################
 * This code was developed by Mickael Vera (1999)
 * MOTOROLA Labs Paris FRANCE
 * NS-2.1b6 enhancements for Wide-Area mobility simulations
 * ############################################################################
 */



#ifndef POINTS_DISTRIBUTION_H
#define POINTS_DISTRIBUTION_H

#define MASS 1     /* grammes */ 
#define WINDY_COEFF 0.7
#define STRENGTH_COEFF 100
#define DT   0.1       /* seconds */
#define THRESHOLD  0.1  /* speed limit in meters / second */

#define WARNINGS
/* #define ABSORBTION */
#define VERBOSE

struct point 
{
  double x ;
  double y ;
} ;

typedef struct point point ;

point *
points_distribution (int nb_points, int X, int Y, float pertubation) ;

void
speeds_increase (point * speed, point * unit_vector, int i, int j, 
		 double distance) ;

void
update_position_and_speeds (point * points, int i, point * speeds,
			    int X, int Y) ;

int
immobile_points (point * speeds, int nb_points) ;

void
compute_mirror_point (point * mirror_point, int i, point * points_array, 
		      int k, point * offset, int X, int Y) ;


#endif /* indef POINTS_DISTRIBUTION_H */ 






