/* This software comprises contributed code made by Motorola, as a
 * Contributor, to Network Simulator NS-2 software provided by the
 * Regents of the University of California.
 * (Copyright; Regents of the University of California, 1994)
 * The contributed code was made as a result of a partnership between
 * Motorola and INRIA Rhone-Alpes.
 *
 * Copyright in the contributed code belongs to Motorola Inc. 2001
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ALL ADVERTISING MATERIALS MENTIONING FEATURES OR USE OF THIS SOFTWARE MUST
 * DISPLAY AN ACKNOWLEDGEMENT TO THE COPYRIGHT OWNERS.
 * ANY REDISTRIBUTION OF THIS SOFTWARE MUST CONTAIN THE ABOVE COPYRIGHT NOTICES,
 * CONDITIONS AND DISCLAIMER.
 */

/* ############################################################################
 * This code was developed by Mickael Vera (1999)
 * Modified by Thierry Ernst (2000)
 * MOTOROLA Labs Paris FRANCE and INRIA Rhone-Alpes FRANCE (Planete)
 * NS-2.1b6 enhancements for Wide-Area mobility simulations
 * ############################################################################
 */



// XXXX I need to do a lot of cleanup in this file. */

#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <assert.h>
#include <ctype.h>

#include "gb_graph.h"
#include "gb_save.h"
#include "points_distribution.h"
#include "addresses.h"
#include "topology_map.h"
#include "nodes_type.h"

#include "sgb2ns_sites.h"

void
debug_display_addresses_domain (int domains, int * clusters, 
				char * node_per_cluster) ;

void 
usage (char * name) 
{ 
  fprintf (stderr, "usage : %s sgb-file.gb\n", name) ;
  // fprintf (stderr, "usage : %s [-enable-random-anchor] anchors-number X Y sgb-file.gb\n", name) ;
  exit (1) ; 
}

int
main(int argc,char ** argv)
{

  Graph *g = NULL ; /* sgb graph */
  FILE *fout = NULL ; /* topology manager script file */

  topology_map T = NULL ;

  int enable_random_anchor = -1 ;
  int anchors_number = -1 ;
  int X = -1 ;
  int Y = -1 ;

  char * tcl_output_file_name = NULL ;
  char * index = NULL ;
  int i  = -1 ;


  /* check command line parameters */
//  switch (argc) {
//  case 5: { /* no -enable-random-anchor */
//    if (strcmp(argv[1], "-enable-random-anchor") == 0)
//      usage (argv[0]) ;
//    enable_random_anchor = 0 ;
//    break ;
//  }
//  case 6: { /* -enable-random-anchor */
//    if (strcmp(argv[1], "-enable-random-anchor") != 0)
//      usage (argv[0]) ;
//    enable_random_anchor = 1 ;
//    fprintf (stderr, "Sorry : -enable_random_anchor option not yet implemented\n") ;
//    break ;
//  }
//  default: {
//    usage (argv[0]) ;
//    break ;
//  }
//  }
//	
//  /* read command line parameters */
//  for (i = 1 + enable_random_anchor; i < argc; i++) {
//    switch (i - enable_random_anchor) {
//    case 1: { /* anchor number */
//      if ( ! is_number(argv[i]))
//	usage (argv[0]) ;
//      anchors_number = atoi (argv[i]) ;
//      break ;
//    }
//    case 2: { /* X */
//      if ( ! is_number(argv[i]))
//	usage (argv[0]) ;
//      X = atoi (argv[i]) ;
//      break ;
//    }
//    case 3: { /* Y */
//      if ( ! is_number(argv[i]))
//	usage (argv[0]) ;
//      Y = atoi (argv[i]) ;
//      break ;
//    }
//    case 4: { /* sgb file */
//      g = restore_graph(argv[i]);
//      if (g == NULL) {
//	printf("%s does not contain a correct SGB graph\n",
//	       argv[i]);
//	return 1;
//     }
//      break ;
//   }
//    }
//  }
//  /* end of read line command parameters */

  // Begin modification
  // XXX: I don't need all those arguments.
  if ( argc != 2 ) usage (argv[0]) ;
 
  anchors_number = 0 ;  
  enable_random_anchor = 0 ;
  X = 0;
  Y = 0;  
  g = restore_graph(argv[1]);
  if (g == NULL) {
	printf("%s does not contain a correct SGB graph\n",argv[1]);
	return 1;
  }
  // End modification

  /* create the output tcl output file name and open it */ 
  //XXX tcl_output_file_name = malloc ((strlen (argv[4]) + 5) * sizeof(char)) ;
  //XXX strcpy (tcl_output_file_name, argv[4]) ;
  tcl_output_file_name = malloc ((strlen (argv[1]) + 5) * sizeof(char)) ;
  strcpy (tcl_output_file_name, argv[1]) ;
  index = strstr (tcl_output_file_name, "gb") ;
  if (index == NULL){
    fprintf (stderr, "The sgb file doesn't have a correct name\n") ;
    fprintf (stderr, "Give it the gb suffix\n") ;
    usage (argv[0]) ;
  }
  sprintf (index, "tcl") ;
  sprintf ((index + 3), "%c", '\0') ;
  fout = fopen (tcl_output_file_name, "w") ;
  if (fout == NULL){
    fprintf (stderr, "Can't open %s\n", tcl_output_file_name) ;
    usage (argv[0]) ;
  }
  
  /* **************************************************************** 
     Here begins the construction of the topology 
     **************************************************************** */
  
//XXX write_human_topology_info (fout, argv[0], enable_random_anchor, anchors_number, 
//XXX			     X, Y, argv[4], tcl_output_file_name) ;
  write_human_topology_info (fout, argv[0], enable_random_anchor, anchors_number, 
			     X, Y, argv[1], tcl_output_file_name) ;
  
  fprintf (fout, "set tm_all_nodes(z) 0 ; #  global variable\n") ;
  
  T = create_ns_addresses (g) ;
  write_tm_build_edges (fout, g, T) ;
  add_anchors (T, 
	       anchors_number, 
	       enable_random_anchor, 
	       X, Y, tcl_output_file_name);
  write_tm_build_nodes (fout, g, T) ;
  write_tm_add_domains_and_stubs (fout, g, T) ;
  
  //  XXX: no need for this anymore
  // write_tm_build_topo (fout, X, Y) ;
  //write_tm_init_addr (fout, T) ;
  
  delete_topology_map (T) ;
  return 0 ;
}

void 
write_human_topology_info (FILE * fout, char *prog, int enable_random_anchor, int anchors_number
			   , int X, int Y, char * sgb_file_name, char * tcl_file_name) 
{
  fprintf (fout, "# tcl file : %s\n", tcl_file_name) ;
  fprintf (fout, "# generated with %s %d %d %d %d %s\n", \
	prog, enable_random_anchor, anchors_number, X, Y, tcl_file_name) ;
  fprintf (fout, "# enable-random-anchor = ") ;
  if (enable_random_anchor == 0)
    fprintf (fout, "No\n") ;
  else
    fprintf (fout, "Yes\n") ;
  fprintf (fout, "# %d anchors / stub\n", anchors_number) ;
  fprintf (fout, "# topography size : %d x %d\n", X, Y) ;
  fprintf (fout, "# sgb file : %s\n\n", sgb_file_name) ;
  fprintf (fout, "# Code by Mickael VERA 12/99 & enhanced by Thierry ERNST 10/00\n") ;
  fprintf (fout, "# MOTOROLA Labs Paris and INRIA Rhone-Alpes\n\n") ;
}

topology_map
create_ns_addresses (Graph * g) 
{
  int current_transit_cluster = -1 ; 
  int current_stub = -1 ; 
  int current_domain = -1;
  int i ;
 
 
  topology_map T ;
  
  Vertex *v = NULL ;  
  
  int a1, a2, a3, a4 ; /* four fields of the sgb address */
  int pa1, pa2, pa3, pa4 ; /* four fields of the previous address */

  a1 = -1 ; a2 = -1 ; a3 = -1 ; a4 = -1 ;

  T = new_topology_map () ;

  for ( v = g->vertices, i = 0 ; i < g->n ; i++, v++ ) {

    pa1 = a1; pa2 = a2; pa3 = a3; pa4 = a4 ;
    switch (v->name[0]) {
    case 'T':
      sscanf (v->name + 2, "%d.%d", &a1, &a2) ;
      if (a1 != current_domain) { /* this is a new domain */
	current_domain = add_domain (T) ;
      }
      current_transit_cluster = add_transit_domain (T, current_domain) ; 
      add_transit_node (T, current_domain, current_transit_cluster) ;

      break ;
    case 'S':
      sscanf (v->name + 2, "%d.%d/%d.%d", &a1, &a2, &a3, &a4) ;
      if (a4 == 0){ /* this is the first node of this stub */
	current_stub = add_stub (T, a1, a2) ;
      }
      add_stub_node (T, a1, a2, current_stub) ;
      // add_stub_node (T, current_domain, current_cluster) ;
      
      break ;
    default:
      printf ("Line %d: Address format error", __LINE__) ;
      exit (1) ;
    }
  }
  return T ;
}

void
write_tm_build_edges(FILE * fout, Graph * g, topology_map T)
{
  int i = 0, j = 0 ;

  Vertex *v = NULL ;  
  Arc *a = NULL ;
  char * bandwidth = NULL ;
  float delay = 0 ;
#if defined TCL_VERBOSE
  int nb_edges = 0 ;
#endif

  fprintf (fout, "proc tm_build_links {} {\n");
  fprintf (fout, "%sglobal tm_all_nodes ns \n\n", TCL_INDENTATION);

  // Thierry: Distinction between Border Node and Stub Node is made here
  // If there is a link between a Transit Node ans a Stub Node, 
  // this node is a Border Node.
  
  for (v = g->vertices,i=0; i < g->n; i++,v++) {
#if defined TCL_VERBOSE
    if ((nb_edges != 0) && (( nb_edges % 100) == 0))
      fprintf (fout, "%sputs -nonewline \"%d \" ; flush stdout\n", 
	       TCL_INDENTATION, nb_edges) ;
    nb_edges ++ ;
#endif
    for (a = v->arcs; a != NULL; a = a->next) {
      j = a->tip - g->vertices;
      if (j > i) { /* don't build two times the same arc */
	/* indentation tm_instance link_method node_origin node_dest bandwidth 
	   delay tail*/ 
	switch (node_type(T,i)){
	case TRANSIT_NODE:
	  {
	    switch (node_type(T,j)) {
	    case TRANSIT_NODE: /* transit-transit link */
	      {
		bandwidth = TRANSIT_TRANSIT_BW ;
		delay = TRANSIT_TRANSIT_DELAY_COEF * a->len ;
		break ;
	      }
	    case STUB_NODE: /* transit-border_router link */
	    case BORDER_NODE:
	      {
		bandwidth = TRANSIT_BORDER_BW ;
		delay = TRANSIT_BORDER_DELAY_COEF * a->len ;
		set_node_type(T,j,BORDER_NODE) ;
		break ;
	      }
	    default:
	      {
		fprintf (stderr, "internal error line %d\n", __LINE__) ;
//		fprintf (stderr, "%d : %s -> %d : %s\n", 
//			 i, node_address(T,i), j, node_address(T,j));
		printf ("types : i %d : j %d\n", node_type(T,i), node_type(T,j));
		exit (1) ;
	      }
	    }
	    break ;
	  }
	case STUB_NODE:
	case BORDER_NODE:
	  {
	    switch (node_type(T,j)) {
	    case TRANSIT_NODE: /* transit-border_router link */
	      {
		bandwidth = TRANSIT_BORDER_BW ;
		delay = TRANSIT_BORDER_DELAY_COEF * a->len ;
		set_node_type(T,i,BORDER_NODE) ;
		break ;
	      }
	    case STUB_NODE: /* intra stub link */
	    case BORDER_NODE:
	      /* !!! doesn't worry about stub-stub extra links of gt=itm */
	      /* this could be resolved by watching at addresses */
	      {
		bandwidth = INTRA_STUB_BW ;
		delay = INTRA_STUB_DELAY_COEF * a->len ;
		break ;
	      }
	    default:
	      {
		fprintf (stderr, "internal error line %d\n", __LINE__) ;
		exit (1) ;
	      }
	    }
	    break ;
	  }
	default:
	  {
	    fprintf (stderr, "internal error line %d\n", __LINE__) ;
	    exit (1) ;
	  }
	}
	
	fprintf(fout, 
		"%s $ns duplex-link $tm_all_nodes(%d) $tm_all_nodes(%d) %s %.2fms %s\n",TCL_INDENTATION, i, j, bandwidth, delay, LINK_TAIL);
      }
    }
  }
#if defined TCL_VERBOSE
  fprintf (fout, "%sputs \"\"\n", TCL_INDENTATION) ;
#endif
  fprintf (fout, "}\n\n");
	
}

void
write_tm_build_topo (FILE * fout, int X, int Y) 
{
  fprintf (fout, "# Do I need this ?\n");
  
  fprintf (fout, "proc %s {} {\n", TM_BUILD_TOPO_PROC) ;
  fprintf (fout, "%sglobal %s opt \n\n", TCL_INDENTATION, TM_INSTANCE) ;
  fprintf (fout, "%sset opt(x) %d\n", TCL_INDENTATION, X);
  fprintf (fout, "%sset opt(y) %d\n\n", TCL_INDENTATION, Y);
//  fprintf (fout, "%s%s\n", TCL_INDENTATION, TM_BUILD_NODES_PROC) ;
// XXX: Thierry - now, we do it separately 
  fprintf (fout, "%s%s\n", TCL_INDENTATION, TM_BUILD_LINKS_PROC) ;
  fprintf (fout, "%s$%s  %s\n", TCL_INDENTATION, TM_INSTANCE, 
	   TM_BUILD_MOBILES_METHOD) ;
  fprintf (fout, "}\n\n") ;
}

void 
write_tm_add_domains_and_stubs (FILE * fout, Graph * g, topology_map T)
{
// XXX: Thierry 9/00:
// Merged with tm_build_nodes
}

void 
write_tm_build_nodes (FILE * fout, Graph * g, topology_map T)
{
  int i = 0 ;
  //char * address ;
  // int cluster ;
  // char * s_index ;

  int transit_domain = -1 ;
  int stub_index = -1 ;  
  int transit_node = -1 ;

  int nb_transit_domains = -1 ;
  int nb_transit_nodes = -1 ;
  int nb_stubs = -1 ;
  int stub_domain = -1 ;
  int domain = -1 ;
  int dom_node = -1 ;
  int stub = -1;

  fprintf (fout, "proc %s {} {\n", TM_BUILD_NODES_PROC) ;
  fprintf (fout, "%sglobal %s \n\n", TCL_INDENTATION, TM_INSTANCE) ;

  transit_domain = 0; 
  nb_transit_domains = get_nb_transit_domains (T) ;
  fprintf (fout, "%s$%s %s %d\n", TCL_INDENTATION, TM_INSTANCE,
             TM_ADD_DOMAIN_METHOD, nb_transit_domains);
  fprintf (fout, "\n");

  nb_transit_nodes = get_nb_transit_nodes (T, transit_domain) ; 
  transit_node = 0;
 
  for (i = 0; i < topology_nb_nodes(T) ; i++) {

#if defined TCL_VERBOSE
   if ((i != 0) && ((i % 100) == 0))
      fprintf (fout, "%sputs -nonewline \"%d \" ; flush stdout\n", 
               TCL_INDENTATION, i) ;
#endif
   // address = node_address(T,i) ;
   // domain = atoi (address) ;
   // s_index = index (address , '.') + 1 ;
   // cluster = atoi (s_index) ; 
   domain = node_domain(T,i);
   dom_node = node_dom_node(T,i);
   stub = node_stub(T,i);

   // XXX: now NS addresses are set in NS direclty      
   // XXX: => should remove address from output
   // XXX: but we need something to output cluster.
 
   switch (node_type(T,i)) {
    case TRANSIT_NODE: {
      fprintf (fout, "%s$%s %s %d %d\n", TCL_INDENTATION, TM_INSTANCE, 
               ADD_TRANSIT_NODE_METHOD, i, domain) ;
      
      nb_stubs = get_nb_stubs (T, transit_domain, transit_node) ;
      fprintf (fout, "%s$%s %s %d %d\n", TCL_INDENTATION, TM_INSTANCE,
		 ADD_NB_STUB_METHOD, i, nb_stubs);
      if ( ++transit_node >= nb_transit_nodes ) { 
	 transit_node = 0;
         if ( ++transit_domain < nb_transit_domains )
  	    nb_transit_nodes = get_nb_transit_nodes (T, transit_domain) ; 
      }
      break ;
    }
    case STUB_NODE: {
      fprintf (fout, "%s$%s %s %d %d\n", TCL_INDENTATION, TM_INSTANCE, 
               ADD_STUB_NODE_METHOD, i, stub) ;
      break ;
    }
    case BORDER_NODE: {
      fprintf (fout, "%s$%s %s %d %d\n", TCL_INDENTATION, TM_INSTANCE, 
               ADD_BORDER_NODE_METHOD, i, stub) ;
      break ;
    }
    case ANCHOR_NODE : {
      // XXX: 9/00 We need to update this in order to choose attachment
      // point of anchor node (Base Station)
      // Pb: we don't necessarily need BS(s) in each stub.
      // Choose 'n' stubs randomly ????
      // XXX: 9/00 - we don't need Z position, but set it to 0
      fprintf (fout, "%s$%s %s %d %d %d %s 0\n", TCL_INDENTATION, TM_INSTANCE,
               ADD_ANCHOR_NODE_METHOD, i, domain, ERROR, node_option(T,i)) ;
      break ;
    }
    default: {
      fprintf (stderr, "internal error : no such type of node line %d\n", __LINE__);
      exit (1);
    }
   } 
  //  free (address) ;
  }
  fprintf (fout, "\n") ;
 
#ifdef TCL_VERBOSE
  fprintf (fout, "%sputs \"\"\n", TCL_INDENTATION);
#endif
  fprintf (fout, "}\n\n") ;
}

 
void
write_tm_init_addr (FILE * fout, topology_map T) 
{
  char * addr_string ;

  fprintf (fout, "proc %s {} {\n", TM_ADDR_INIT_PROC) ;
  fprintf (fout, "%sglobal %s %s\n\n", TCL_INDENTATION, NS_INSTANCE, 
	   TM_INSTANCE) ;

  fprintf (fout, "%s$%s %s ", TCL_INDENTATION, TM_INSTANCE, 
	   TM_ADDR_INIT_PROC) ;

  addr_string = get_topology_addresses_domain (T) ;
  fprintf (fout, "%s\n}\n\n", addr_string) ;
  free (addr_string) ;
}

char *
get_ip_prefix (char * address) 
{
  char * ip_prefix = NULL ;
  char * pindex = NULL ;
  
  ip_prefix = strdup (address) ;
  pindex = index (ip_prefix, '.') ;
  pindex = index (pindex + 1, '.') ;
  *pindex = '\0' ;

  return ip_prefix ;
}

int
is_number (char * string) 
{
  int i ;
  
  for (i = 0; i < strlen (string); i++)
    if (! isdigit(string[i]))
      return FALSE ;
  return TRUE ;
}


void
add_anchors (topology_map T, int anchors_number, int enable_random_anchor, 
	     int X, int Y, char * file_name)
{
  int nb_transit_domains = -1 ;
  int nb_transit_nodes = -1 ;
  int nb_stubs = -1 ;
  int transit_domain = -1 ;
  int transit_node = -1 ;
  int stub = -1 ;
  int stub_domain = 0 ;
  int anchor = -1 ;
  char * options = (char *) malloc (sizeof (char) * MAX_NODE_OPTION_STRING_SIZE) ;

  point * coordinates_array = NULL ;
#ifdef INTERACTIVE
  char name[100] ;
  char * cursor = NULL ;
  FILE * plot_cmd = NULL ;
  FILE * plot_data = NULL ;
  char c ;
#endif
  assert (enable_random_anchor == 0) ;

  nb_transit_domains = get_nb_transit_domains (T) ;
  for (transit_domain = 0; transit_domain < nb_transit_domains; transit_domain ++ ) {
    nb_transit_nodes = get_nb_transit_nodes (T, transit_domain) ;
    for (transit_node = 0; transit_node < nb_transit_nodes; transit_node++) {
      nb_stubs = get_nb_stubs (T, transit_domain, transit_node) ;
      for (stub = 0; stub < nb_stubs; stub ++){
	stub_domain ++ ;
#ifdef INTERACTIVE
	/* create name for the gnuplot date file */
	strcpy (name, file_name) ;
	cursor = strstr (name, "tcl") ;
	assert (cursor != NULL) ;
	sprintf (cursor, "%d.plot_data%c", stub, '\0') ;
	
	/* create the gnuplot command file */
	plot_cmd = fopen ("plot_cmd", "w") ;
	fprintf (plot_cmd, "plot [0:%d] [0:%d] '%s' ; pause -1 \n", X, Y, name ) ;
	fclose (plot_cmd) ;
#endif	
	/* give coordinates to anchor nodes for one stub 
	   until the user accepts */ 
	do {
	  /* compute points coordinates */
	  coordinates_array = points_distribution (anchors_number, X, Y, 0.5) ;
	  
#ifdef INTERACTIVE
	  /* write the gnuplot data file */
	  plot_data = fopen (name, "w") ;
	  for (anchor = 0; anchor < anchors_number; anchor++)
	    fprintf (plot_data, "%f %f\n", coordinates_array[anchor].x, 
		     coordinates_array[anchor].y);
	  fclose (plot_data) ;

	  /* call gnuplot */
	  system ("gnuplot plot_cmd") ;
	  do {
	    c = getchar () ;
	  } while (c != '\n') ;
	  do {
	    printf ("Is this configuration OK (y/n) ?") ;
	    
	    c = getchar () ;
	  } while (c != 'y' && c != 'n') ;
	} while (c != 'y') ;
#endif
	
#ifndef INTERACTIVE
      } while (0) ;
#endif
      
      for (anchor = 0; anchor < anchors_number; anchor++) {
	snprintf (options, MAX_NODE_OPTION_STRING_SIZE, "%.2f %.2f",
		  coordinates_array[anchor].x, 
		  coordinates_array[anchor].y) ;
	add_anchor_node (T, stub_domain, options) ; 
      }
    }
  }
}

free (coordinates_array) ;
free (options) ;
}










