/* This software comprises contributed code made by Motorola, as a
 * Contributor, to Network Simulator NS-2 software provided by the
 * Regents of the University of California.
 * (Copyright; Regents of the University of California, 1994)
 * The contributed code was made as a result of a partnership between
 * Motorola and INRIA Rhone-Alpes.
 *
 * Copyright in the contributed code belongs to Motorola Inc. 2001
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ALL ADVERTISING MATERIALS MENTIONING FEATURES OR USE OF THIS SOFTWARE MUST
 * DISPLAY AN ACKNOWLEDGEMENT TO THE COPYRIGHT OWNERS.
 * ANY REDISTRIBUTION OF THIS SOFTWARE MUST CONTAIN THE ABOVE COPYRIGHT NOTICES,
 * CONDITIONS AND DISCLAIMER.
 */

/* ############################################################################
 * This code was developed by Mickael Vera (1999)
 * MOTOROLA Labs Paris FRANCE
 * NS-2.1b6 enhancements for Wide-Area mobility simulations
 * ############################################################################
 */



#ifndef TOPOLOGY_MAP_H
#define TOPOLOGY_MAP_H

#define MAX_TOPOLOGY_NODES 10000
#define MAX_TRANSIT_NODE_PER_TRANSIT_DOMAIN 120 
#define MAX_TN_PER_DOMAIN 120 
#define MAX_STUB_PER_TRANSIT_NODE 120 
#define MAX_NODES_PER_STUB 120 

#define MAX_NODES_BY_STUB 120 
#define MAX_ANCHORS_BY_STUB 20

#define MAX_NODE_OPTION_STRING_SIZE 100


/* Thierry */
#define DEFAULT_TN_CLUSTER	0 
#define ERROR			-1
#define NONE 			-1

struct topology_map ;
typedef struct topology_map * topology_map ;

topology_map
new_topology_map () ;

void
delete_topology_map (topology_map T) ;

int
add_transit_domain (topology_map T, int domain) ;

int
add_transit_node (topology_map T, int transit_domain, int cluster) ;

int
add_domain (topology_map T) ;

int
add_stub (topology_map T, int domain, int cluster) ;

int
add_stub_node (topology_map T, int domain, int dom_node, int stub) ;

int
add_stub_node_with_option (topology_map T, int domain, 
			   int type, const char * options) ;

void
add_anchor_node (topology_map T, int domain, char * option) ;

int
node_type (topology_map T, int node_index) ;

int
node_domain (topology_map T, int node_index) ;

int
node_dom_node (topology_map T, int node_index) ;

int
node_stub (topology_map T, int node_index) ;

void
set_node_type (topology_map T, int node_index, int type) ;

char *
node_address (topology_map T, int node_index) ;

char *
node_option (topology_map T, int node_index) ; 

int
topology_nb_nodes (topology_map T) ; 

int
get_nb_transit_domains (topology_map T) ;

int
get_nb_transit_domains (topology_map T) ;

int
get_nb_transit_nodes (topology_map T, int Transit_domain) ;

int
get_nb_stubs (topology_map T, int Transit_domain, int Node) ;

// int
//get_stub_address_domain (topology_map T, int Transit_domain, 
//			 int Node, int stub_index) ;

char *
get_topology_addresses_domain (topology_map T) ;

#endif /* TOPOLOGY_MAP_H */
