# ##################################################################### 
# Thierry Ernst 2000-2001
# Defaults Options and configuration parameters for MOBIWAN  simulations
# Based on ns-2.1b6 
# #####################################################################

# #####################################################################
# Default Simulations Parameters
# The following may be passed to NS on the command line
# #####################################################################
#set opt(iface)          ALL		; # ALL / LIGHT 
set opt(global)		OFF

set opt(mactrace)	ON		; # ON / OFF works only if iface = ALL
set opt(mn_nn) 		0         	; # nb of MNs (not base stations)
set opt(bs_nn)		0	  	; # nb of BSs per site 
set opt(cn_nn)		0	  	; # nb of CNs 

set opt(cn_traffic)	NONE		; # Type of traffic between CN and MN
set opt(site_config) 	NONE
set opt(mn_config) 	NONE 
set opt(rp_config) 	NONE 
set opt(bs_config) 	NONE 
set opt(cn_config) 	NONE
set opt(scen_config) 	NONE 

set opt(protocol) 	UBU		; # OFF | MBU | UBU 
set opt(mcast_proto)    CtrMcast 	; # OFF |  CtrMcast	
set opt(stop)          		1000 	; # end of simulation   
set opt(record_interval)	20 	; # trace is flushed every interval 
set opt(x)                      800
set opt(y)                      400
set opt(topoman)	ALL
set opt(seed)		1

# #####################################################################
# DISPLAYING OUTPUT  
# #####################################################################
set opt(DISPLAY_INPUT) 	FALSE	; # Output Display :  TRUE | FALSE
set opt(DISPLAY_INFO)	FALSE	; # Record some info in file  :  TRUE | FALSE
set opt(NAM)		0	; # NAM: 1=set visu 0=unset visu
set opt(RUN)		TRUE	; # Running NS
set opt(DISPLAY_DIST) 	FALSE	; # Display Routing Table Distances: TRUE | FALSE
  
# #####################################################################
# Default Files 
# #####################################################################
# Input Files 
#
set opt(config_file)		NONE 	; # NONE | config instructions
set opt(bs_config_file)		NONE 	; # NONE | bs config instructions
set opt(cn_config_file)		NONE 	; # NONE | cn config instructions
set opt(site_config_file)	NONE	; # NONE | site config instrructions 
set opt(scen_file)		NONE	; # mobility scenario file
set opt(topo_file)		NONE	; # topology 
set opt(site_file)		NONE	; # site topology 

#
# Output Files
#
set opt(tracefile)      out.tr		; # NS output
set opt(namfile)        out.nam		; # NAM output
set opt(infofile)	stdout		; # Misc info output
