#!/bin/tcsh

# ######################################################################
# Demonstration of Mobile IPv6 for local mobility and global mobility 
# Thierry Ernst
# Version 08.05.01
# ######################################################################
set topos = (small-topo-by-hand micro-test-20-0 t-10-100-450-0-0 )
   
   # Output Directory
   set OUTDIR=.tmp
   echo "Output in temporary directory $OUTDIR"
   if ( -d $OUTDIR ) then
	rm -R $OUTDIR
   endif
   mkdir $OUTDIR

foreach topo ( $topos )
   set MOBI=.. 
   set cn_nn=1				# nb of CNs
   set NS=ns-mipv6			# NS binary
   set bs_nn=4				# nb of Base Stations per site
   set nb_site=8			# nb of Sites where we want Base Stations
   set mt=500				# Movement time interval
   set stop=`expr $mt \* $nb_site`	# Stop time

   # Input Directories
   set TOPOD={$MOBI}/topologies 	# Directory for topologies
 
   # Input Files
   set scriptf=mipv6.tcl 
   set TOPOF={$TOPOD}/{$topo}.tcl	# topology file path
  
   set NAMF={$OUTDIR}/{$topo}.nam		# NAM file (optional)
   set TRACEF={$OUTDIR}/{$topo}.tr
   set INFOF={$OUTDIR}/{$topo}.info   

   # Launch simulation  
   $NS mipv6.tcl -topoman ALL -RUN FALSE -DISPLAY_INFO TRUE -DISPLAY_INPUT TRUE file -topo_file $TOPOF -tracefile $TRACEF > $INFOF 

end  
